{
        Fake true color plasma coded by Scout/SuccesS (rolando@knoware.nl)

        If you use it..CREDIT ME!
}

{$G+}           {Activate 286+ opcodes}

Const
    MaxTab = 256;
    Page   : Byte = 0;


Type
    Tabel = Array[0..MaxTab] of Word;

Var
   Sine  : Tabel;
   Sine2 : Tabel;
   T,T2  : Word;

Function Escape:Boolean;
Begin
    Escape:=False;
    If Port[$60]=1 then Escape:=True;
End;


Procedure WaitVbl;Assembler;
Asm
           mov   dx,3dah
@1:        in    al,dx

           test  al,8
           jnz   @1
@2:        in    al,dx
           test  al,8
           jz    @2
End;

Procedure VideoMode(Mode:Byte);Assembler;
Asm
           mov   ah,0
           mov   al,Mode
           int   10h
End;


Procedure SetColor (Color,R,G,B:Byte);
Begin
    Port[$3c8]:=Color;
    Port[$3c9]:=R;
    Port[$3c9]:=G;
    Port[$3c9]:=B;
End;


Procedure Flip;
Var
  OfsAdr : Word;
Begin
  OfsAdr := Page * 32000;
Asm
           mov    dx,03D4h
           mov    al,0Dh
           out    dx,al
           inc    dx

           mov    ax,OfsAdr
           out    dx,al
           dec    dx
           mov    al,0Ch
           out    dx,al
           inc    dx
           mov    al,ah
           out    dx,al
End;

  Page := 1 - Page;
End;


Procedure Set320x400;Assembler;
ASM
           mov    dx,03c4h
           mov    al,04h
           out    dx,al
           inc    dx
           in     al,dx
           and    al,0c7h
           or     al,04h
           out    dx,al

           mov    dx,03c4h
           mov    al,02h
           out    dx,al
           inc    dx
           mov    al,0fh
           out    dx,al                { Leave all planes on! }

           mov    dx,03d4h
           mov    al,9
           out    dx,al
           inc    dx
           mov    al,0
           out    dx,al

           mov    ax,0a000h
           mov    es,ax
           xor    di,di
           xor    ax,ax
           mov    cx,8000h
           rep    stosw
           mov    dx,03d4h
           mov    al,14h
           out    dx,al
           inc    dx
           in     al,dx
           and    al,0bfh
           out    dx,al

           dec    dx
           mov    al,17h
           out    dx,al
           inc    dx
           in     al,dx
           or     al,40h
           out    dx,al

End;


Procedure Sinus(Var Tab:Tabel;MTab,Radius:Integer);
Var
   T : Word;
Begin
     For T:=0 to MaxTab do
     Tab[T]:=Round(Sin((2*Pi)/Mtab*T)*(Radius/2)+(Radius/2));
End;


Procedure CoSinus(Var Tab:Tabel;MTab,Radius:Integer);
Var
   T : Word;
Begin
     For T:=0 to MaxTab do
     Tab[T]:=Round(Cos((2*Pi)/Mtab*T)*(Radius/2)+(Radius/2));
End;

Procedure Plot (X, Y : Integer; Colour : Byte );Assembler;
ASM
    mov    ax,Word Ptr Page
    mov    cx,32000
    imul   cx

    mov    bx,X
    shr    bx,2
    mov    di,Y

    mov    cx,di
    shl    di,6
    shl    cx,4         { Alternative *80 }
    add    di,cx
    add    di,bx

    mov    bx,0A000h
    mov    es,bx
    add    di,ax

    mov    al,Colour
    mov    es:[di],al
    add    al,64
    mov    es:[di+80],al
    add    al,64
    mov    es:[di+160],al
end;


Procedure Plasma;
{ Wow! Look at the plasma formula! ;) }

Var
   X,Y : Word;
Begin
    For Y:=0 to 132 do
    For X:=0 to 79 do
    Plot (X*4,Y*3,(X+((Y+Sine2[(((Sine[(X+T) and 255])+(Sine[(Y+T2) and 255])+Sine[(X+Sine2[(Y+T) and 255]) and 255]))
    and 255]) shr 3)) and 63);

    Inc (T,1);
    Inc (T2,-1);

End;


Procedure SetPalette;
Var
   T : Byte;
   S : Byte;
Begin
     For T:=0 to 31 do
         Begin
             SetColor (T,    T, 0        , T);
             SetColor (T+64, T                   , T and 63 , 33);
             SetColor (T+128,T                   , ((T*6) div 4)       , T and 63);
         End;

     S:=32;
     For T:=32 to 63 do
         Begin
             SetColor (T,     S, 0        , S);
             SetColor (T+64,  S                   , S and 63 ,33);
             SetColor (T+128, S                   , ((S*6) div 4) and 63 , S and 63);
             Dec (S);
         End;


End;

Procedure Init;
Begin
     VideoMode ($13);
     Set320x400;

     SetPalette;

     Sinus (Sine,MaxTab,256);
     CoSinus (Sine2,MaxTab,256);
End;

Begin
     Init;
     Repeat
           Flip;
           WaitVbl;
           Plasma;
     Until Escape;
     VideoMode (3);
End.

